## mapDamage

[![install with bioconda](https://img.shields.io/badge/install%20with-bioconda-brightgreen.svg?style=flat)](http://bioconda.github.io/recipes/mapdamage2/README.html) [![Conda](https://img.shields.io/conda/dn/bioconda/mapdamage2.svg)](https://anaconda.org/bioconda/mapdamage2/files)

![Conda](https://anaconda.org/bioconda/mapdamage2/badges/latest_release_date.svg) ![Conda](https://anaconda.org/bioconda/mapdamage2/badges/version.svg) [![Project Status: Inactive – The project has reached a stable, usable state but is no longer being actively developed; support/maintenance will be provided as time allows.](https://www.repostatus.org/badges/latest/inactive.svg)](https://www.repostatus.org/#inactive)

### Installation

mapDamage can be installed via pip:

```bash
pip install mapdamage
```

R and several packages are *post mortem* damage plotting, modeling, and rescaling. Refers to the detailed instructions on the [dedicated page](http://ginolhac.github.io/mapDamage/).

### Introduction

Complete documentation, instructions, examples, screenshots and FAQ are available at [this address](http://ginolhac.github.io/mapDamage/).

[mapDamage2](https://geogenetics.ku.dk/publications/mapdamage2.0/) is a computational framework written in **Python3** and **R**, which tracks and quantifies DNA damage patterns
among ancient DNA sequencing reads generated by Next-Generation Sequencing platforms.

`mapDamage` was developed at the [Centre for GeoGenetics](https://geogenetics.ku.dk/) by the [Orlando Group](https://geogenetics.ku.dk/research_groups/palaeomix_group/).

### Citation

If you use this program, please cite the following publication:
Jónsson H, Ginolhac A, Schubert M, Johnson P, Orlando L.
[mapDamage2.0: fast approximate Bayesian estimates of ancient DNA damage parameters.
*Bioinformatics* 23rd April 2013. doi: 10.1093/bioinformatics/btt193](http://bioinformatics.oxfordjournals.org/content/early/2013/05/17/bioinformatics.btt193)

The original `mapDamage1` was published in the following article:
Ginolhac A, Rasmussen M, Gilbert MT, Willerslev E, Orlando L.
[mapDamage: testing for damage patterns in ancient DNA sequences. *Bioinformatics* 2011 **27**(15):2153-5
http://bioinformatics.oxfordjournals.org/content/27/15/2153](http://bioinformatics.oxfordjournals.org/content/27/15/2153)

### Test the no-stats part and rescaling

you can test `mapDamage` by running:

```bash
cd mapDamage/mapdamage/
python3 mp_test.py
```

should return

```
Started with the command: /usr/local/bin/mapDamage -i tests/test.bam -r tests/fake1.fasta -d tests/results --no-stats
 Reading from 'tests/test.bam'
 Writing results to 'tests/results/'
pdf tests/results/Fragmisincorporation_plot.pdf generated
additional tests/results/Length_plot.pdf generated
Successful run
.
----------------------------------------------------------------------
Ran 2 tests in 3.357s

OK
```

### Contact

Please report bugs and suggest possible improvements on GitHub:
<https://github.com/ginolhac/mapDamage/issues/new>

Introduction
------------

Seqtk is a fast and lightweight tool for processing sequences in the FASTA or
FASTQ format. It seamlessly parses both FASTA and FASTQ files which can also be
optionally compressed by gzip.

Written by Heng Li.

This version was reduced to perform only the `comp` function and integrated to mapDamage.
The original version can be found here  
https://github.com/lh3/seqtk

#Runs likelihood optimization in the beginning to 
#start in a better place.

logLikAllOptimize  <- function(x,cp){
    #Optimizer wrapper for the log likelihood function
    Theta      <- x["Theta"]       
    DeltaD      <- x["DeltaD"]       
    DeltaS      <- x["DeltaS"]
    Lambda      <- x["Lambda"]
    LambdaRight <- x["LambdaRight"]
    LambdaDisp  <- x["LambdaDisp"]
    Rho         <- x["Rho"]
    if (sum(c(DeltaD,DeltaS,Lambda,LambdaRight)>1)>0 || sum(c(Theta,DeltaD,DeltaS,Lambda,LambdaRight,Rho)<0)>0){
        #This very convenient for lazy people, using a unbounded optimization method Nelder-Mead 
        #just returning Inf when we are outside the boundary.
        return(Inf)
    }
    if(cp$fix_ti_tv){
        theta_mat  <- getPmat(Theta,cp$Rho,cu_pa$acgt)
    }else {
        theta_mat  <- getPmat(Theta,Rho,cu_pa$acgt)
    }
    if (cp$fix_disp){
        disp_to_use =  cp$LambdaDisp
    }else {
        disp_to_use = LambdaDisp
    }
    leftLaVec  <- seqProbVecLambda(Lambda,disp_to_use,cu_pa$m,cu_pa$forward_only,cu_pa$reverse_only)
    rightLaVec  <- seqProbVecLambda(LambdaRight,disp_to_use,cu_pa$m,cu_pa$forward_only,cu_pa$reverse_only)
    if (cp$same_overhangs){
        rightLaVec <- leftLaVec
    }
    if (cp$forward_only){
        #Only using the forward end
        laVec <- leftLaVec
    }else if (cp$reverse_only){
        #Only using the backward end
        laVec <- rightLaVec
    }else {
        #Both ends
        laVec <- c(leftLaVec[1:(cu_pa$m/2)],rightLaVec[(cu_pa$m/2+1):cu_pa$m])
    }
    return(-logLikAll(cp$dat,theta_mat,DeltaD,DeltaS,laVec,cp$nuVec,cp$m))
}

gridSearch <- function(cp,iter){
    #Starts the Markov chain in local maxima for "quicker" burn-in period
    #No theoretical reasoning behind this but seems to work well in practice.
    if (cp$nuSamples!=0){
        write("Can't use the grid search with simulated nu vector",stderr())
        stop()
    }
    if(!cp$quiet){
        cat("Starting grid search, starting from random values\n")
    }
    minVal <- Inf
    minParams <- list()
    control  <- list(maxit=5000)
    for (i in 1:iter){
        out <- optim(
                     c(Theta=runif(1),
                       DeltaD=runif(1),
                       DeltaS=runif(1),
                       Lambda=runif(1),
                       LambdaRight=runif(1),
                       LambdaDisp=sample(c(0.5,1,2,3,4,50,100,150,400),1),
                       Rho=sample(c(0.5,.75,1,1.25,1.5),1)
                      ),
                     logLikAllOptimize,
                     NULL,
                     cp=cp,
                     method="Nelder-Mead",
                     control=control
                     )
        if (out$value<minVal){
            minParams <- out
            minVal <- out$value
        }
        if (cp$verbose){
            cat("Iteration\t",i,"\t",-minVal,"\n")
        }
    }
    #These parameters are always optimized
    cp$Theta <- minParams$par["Theta"]
    cp$DeltaD <- minParams$par["DeltaD"]
    cp$DeltaS <- minParams$par["DeltaS"]
    cp$Lambda <- minParams$par["Lambda"]
    
    #Only update the other ones if the user requested for them
    if (!cp$fix_ti_tv){
        cp$Rho  <- minParams$par["Rho"]
    }
    if (!cp$fix_disp){
        cp$LamdaDisp  <- minParams$par["LambdaDisp"]
    }
    if (!cp$same_overhangs){
        cp$LamdaRight  <- minParams$par["LambdaRight"]
    }

    #Now calculating matrix and vectors accompanying the optimal values
    cp$laVec <- seqProbVecLambda(cp$Lambda,cp$LambdaDisp,nrow(cp$dat),cp$forward_only,cp$reverse_only)
    cp$laVecRight <- seqProbVecLambda(cp$Lambda,cp$LambdaDisp,nrow(cp$dat),cp$forward_only,cp$reverse_only)
    cp$ThetaMat <- getPmat(cp$Theta,cp$Rho,cp$acgt)
    cp$old_lik <- - minVal

    return(cp)
}

#The posterior conditional function utilized by the 
# Gibbs sampler in function.R. They have all the 
#same form maybe they should be implemented in a 
#smarter way.

#The basic structure is the following 

#1. Get the old parameter 
#2. Propose a jump
#3. Accept it using the MH ratio
#4. Return the old or new value based on the MH ratio

updateTheta <- function(cp){
    old_lik  <- cp$old_lik+priorTheta(cp$Theta)
    theta_star <- proposeTheta(cp$Theta,1)
    if (theta_star<0 ){
        new_lik<- -Inf
    } else {
        theta_star_mat  <- getPmat(theta_star,cp$Rho,cp$acgt)
        new_lik_func  <-  logLikAll(cp$dat,theta_star_mat,cp$DeltaD,cp$DeltaS,cp$laVec,cp$nuVec,cp$m)
        new_lik <- new_lik_func+priorTheta(theta_star)
    }
    if (metroDesc(new_lik,old_lik)) {
        #Accept
        cp$Theta  <- theta_star
        cp$ThetaMat  <- theta_star_mat
        cp$old_lik <- new_lik_func
    }
    return(cp)
}

updateRho <- function(cp){
    old_lik  <- cp$old_lik+priorRho(cp$Rho)
    rho_star <- proposeRho(cp$Rho,1)
    if (rho_star<=0 ){
        new_lik<- -Inf
    } else {
        rho_star_mat  <- getPmat(cp$Theta,rho_star,cp$acgt)
        new_lik_func  <-  logLikAll(cp$dat,rho_star_mat,cp$DeltaD,cp$DeltaS,cp$laVec,cp$nuVec,cp$m)
        new_lik <- new_lik_func+priorRho(rho_star)
    }
    if (metroDesc(new_lik,old_lik)) {
        #Accept
        cp$Rho  <- rho_star
        cp$ThetaMat  <- rho_star_mat
        cp$old_lik <- new_lik_func
    }
    return(cp)
}

updateDeltaD <- function(cp){
    old_lik <- cp$old_lik+priorDeltaD(cp$DeltaD)
    deltad_star <- proposeDeltaD(cp$DeltaD,1)
    if (deltad_star<0 || deltad_star>1){
        new_lik <- -Inf
    }else {
        new_lik_func <- logLikAll(cp$dat,cp$ThetaMat,deltad_star,cp$DeltaS,cp$laVec,cp$nuVec,cp$m)
        new_lik <- new_lik_func+priorDeltaD(deltad_star)
    }
    if (metroDesc(new_lik,old_lik)) {
        #Accept
        cp$DeltaD  <- deltad_star
        cp$old_lik <- new_lik_func
    }
    return(cp)
}

updateDeltaS <- function(cp){
    old_lik  <- cp$old_lik+priorDeltaS(cp$DeltaS)
    deltas_star <- proposeDeltaS(cp$DeltaS,1)
    if (deltas_star<0|| deltas_star>1){
        new_lik <- -Inf
    }else {
        new_lik_func  <- logLikAll(cp$dat,cp$ThetaMat,cp$DeltaD,deltas_star,cp$laVec,cp$nuVec,cp$m)
        new_lik  <- new_lik_func+priorDeltaS(deltas_star)
    }
    if (metroDesc(new_lik,old_lik)) {
        #Accept
        cp$DeltaS  <- deltas_star
        cp$old_lik <- new_lik_func
    }
    return(cp)
}

updateLambda <- function(cp){
    old_lik  <- cp$old_lik+priorLambda(cp$Lambda)
    lambda_star <- proposeLambda(cp$Lambda,1)
    if (lambda_star<0 || lambda_star>1){
        return(cp)
    } 
    laVecStarLeft  <- seqProbVecLambda(lambda_star,cp$LambdaDisp,cp$m,cp$forward_only,cp$reverse_only)
    if (!cp$same_overhangs){
        #The left and right overhangs are not the same!
        laVecStar <- c(laVecStarLeft[1:(cp$m/2)],cp$laVecRight[(cp$m/2+1):cp$m])
    } else {
        #It left and right are the same
        laVecStar <- laVecStarLeft
    }
    new_lik_func  <- logLikAll(cp$dat,cp$ThetaMat,cp$DeltaD,cp$DeltaS,laVecStar,cp$nuVec,cp$m)
    new_lik  <- new_lik_func+priorLambda(lambda_star)
    if (metroDesc(new_lik,old_lik)) {
        #Accept
        cp$Lambda  <- lambda_star
        cp$laVec  <- laVecStar
        cp$old_lik <- new_lik_func
    }
    return(cp)
}

updateLambdaRight <- function(cp){
    old_lik  <- cp$old_lik+priorLambdaRight(cp$LambdaRight)
    lambda_right_star <- proposeLambdaRight(cp$LambdaRight,1)
    if (lambda_right_star<0 || lambda_right_star>1){
        #Reject this right away
        return(cp)
    } 
    laVecStarRight  <- seqProbVecLambda(lambda_right_star,cp$LambdaDisp,cp$m,cp$forward_only,cp$reverse_only)
    if (!cp$same_overhangs){
        #The left and right overhangs are not the same!
        laVecStar <- c(cp$laVec[1:(cp$m/2)],laVecStarRight[(cp$m/2+1):cp$m])
    } else {
        #left and right are the same
        print("You shouldn't be calling this function if the overhangs are the same")
        stop()
    }
    if (cp$forward_only){
        print("You shouldn't be calling this function if you are only considering the forward part")
        stop()
    }
    if (cp$reverse_only){
        print("You shouldn't be calling this function if you are only considering the reverse part")
        stop()
    }
    new_lik_func  <- logLikAll(cp$dat,cp$ThetaMat,cp$DeltaD,cp$DeltaS,laVecStar,cp$nuVec,cp$m)
    new_lik  <- new_lik_func+priorLambdaRight(lambda_right_star)
    if (metroDesc(new_lik,old_lik)) {
        #Accept
        cp$LambdaRight  <- lambda_right_star
        cp$laVecRight  <- laVecStar
        cp$old_lik <- new_lik_func
    }
    return(cp)
}

updateLambdaDisp <- function(cp){
    old_lik  <- cp$old_lik+priorLambdaDisp(cp$LambdaDisp)
    lambda_disp_star <- proposeLambdaDisp(cp$LambdaDisp,1)
    if (lambda_disp_star<0 ){
        return(cp)
    } 
    if (!cp$same_overhangs){
        leftLaVecStar  <- seqProbVecLambda(cp$Lambda,lambda_disp_star,cp$m,cp$forward_only,cp$reverse_only)
        rightLaVecStar  <- seqProbVecLambda(cp$LambdaRight,lambda_disp_star,cp$m,cp$forward_only,cp$reverse_only)
        laVecStar <- c(leftLaVecStar[1:(cp$m/2)],rightLaVecStar[(cp$m/2+1):cp$m])
    }else {
        laVecStar  <- seqProbVecLambda(cp$Lambda,lambda_disp_star,cp$m,cp$forward_only,cp$reverse_only)
    }
    new_lik_func  <- logLikAll(cp$dat,cp$ThetaMat,cp$DeltaD,cp$DeltaS,laVecStar,cp$nuVec,cp$m)
    new_lik  <- new_lik_func+priorLambdaDisp(lambda_disp_star)
    if (metroDesc(new_lik,old_lik)) {
        #Accept
        cp$LambdaDisp  <- lambda_disp_star
        cp$laVec  <- laVecStar
        cp$old_lik <- new_lik_func
    }
    return(cp)
}

updateNu <- function(cp){
    old_lik  <- cp$old_lik+priorNu(cp$Nu)
    nu_star <- proposeNu(cp$Nu,1)
    if (nu_star<0 || nu_star>1){
        return(cp)
    }
    nu_Vec_star <- seqProbVecNuWithLengths(cp$Lambda,cp$LambdaDisp,nu_star,cp$m,sampleHJ(cp$lengths$Length,size=cp$nuSamples,prob=cp$lengths$Occurences),cp$mLe,cp$forward_only,cu_pa$nuSamples,cu_pa$ds_protocol)
    new_lik_func  <- logLikAll(cp$dat,cp$ThetaMat,cp$DeltaD,cp$DeltaS,cp$laVec,nu_Vec_star,cp$m)
    new_lik  <- new_lik_func+priorNu(nu_star)
    if (metroDesc(new_lik,old_lik)) {
        #Accept
        cp$Nu  <- nu_star
        cp$nuVec  <- nu_Vec_star
        cp$old_lik <- new_lik_func
    }
    return(cp)
}

#! /usr/bin/Rscript
#Parses the command line arguments and calls the main program

#Enable full backtraces on errors
on_error <- function(e)
  {
    traceback(2)
    quit(status = 1)
  }
options(error = on_error)

rm(list=ls())
graphics.off()

argsList<-commandArgs(TRUE) #Assuming the user is not using this script directly
argsList <- argsList[-1]  #Skip --args


#######################################################
#
#                  Proposal parameters 
#
#######################################################

proposeParameters <- list( 
                          Theta=0.0003,
                          Rho=0.001,
                          DeltaD=0.001,
                          DeltaS=0.009,
                          Lambda=0.008,
                          LambdaRight=0.008,
                          LambdaDisp=0.015,
                          Nu=0.001
                          )

#######################################################
#
#                  Initial values
#
#######################################################


start_vals <- list(
                   ptrans = 0.00396/3,
                   rho = 1,
                   deltad = 0.0285,
                   deltas = 0.269,
                   lambda = 0.27,
                   lambda_right = 0.27,
                   lambda_disp = 1,
                   len = 60,
                   nu = 0.0645
                   )


#######################################################
#
#                   Various parameters
#
#######################################################

grid_iter <- as.integer(argsList[1])                 # Number of random starting points for the grid search
burn_in <- as.integer(argsList[2])                   # Burn in period
adjust_iter <- as.integer(argsList[3])               # Adjust proposal variance parameters iterations
iterations <- as.integer(argsList[4])                # Iterations

forward_only <- as.logical(as.numeric(argsList[5]))  # Taking only the 5' end of the seqs 
reverse_only <- as.logical(as.numeric(argsList[6]))  # Taking only the 3' end of the seqs 
fix_disp <- as.logical(as.numeric(argsList[7]))      # Geom instead of neg Bin 
same_overhangs <- as.logical(as.numeric(argsList[8]))# The overhangs are the same on both sides

nu_samples <- as.integer(argsList[9])                # Estimate the nu vector using the Briggs model (Should be similiar ammount to the number of sequences use this on your own risk....)
fix_nu <- as.logical(as.numeric(argsList[10]))       # Set 1 at 5' end and 0 at 3' end or else estimates it with GAM
ds_protocol <- as.logical(as.numeric(argsList[11]))  # Single stranded protocol C>T at both sides
sub_length <- as.integer(argsList[12])               # How long sequence to use from each side 

path_to_dat <- argsList[13]                          # Absolute path to the dataset
path_to_mapDamage_stats <- argsList[14]              # Absolute path to the mapDamage-stats folder
out_file_base  <- argsList[15]                       # Base file name of the output
verbose <- as.logical(as.numeric(argsList[16]))      # These options control the volume of the output
quiet <- as.logical(as.numeric(argsList[17]))

jukes_cantor <- as.logical(as.numeric(argsList[18])) # Fix the transition and transversion ratio and acgt frequencies are equal
path_to_acgt <- argsList[19] 
use_raw_nick_freq <- as.logical(as.numeric(argsList[20]))
use_bw_theme <- as.logical(as.numeric(argsList[21]))


#######################################################
#
#                   Run the program
#
#######################################################

source(paste(path_to_mapDamage_stats,"main.R",sep=""))

#Various useful functions
getPmat <- function(tmu,tv_ti_ratio,acgt){
    #Returns the evolutionary substitution matrix  
    if (sum(acgt>=1)!=0 || sum(acgt<=0)!=0){
        write("The ACGT frequencies must be in the range 0 to 1",stderr())
        stop()       
    }
    if (all.equal(sum(acgt),1)!=TRUE){
        write("The ACGT frequencies do not sum to 1",stderr())
        stop()       
    }
    if (tv_ti_ratio<=0){
        write("The transversion and transtition ratio cannot go under 0",stderr())
        stop()       
    }
    #Returns the substitution probability matrix.
    if (identical(tv_ti_ratio,1) && identical(acgt,c(.25,.25,.25,.25))){
        return(jukesCantorPmat(tmu))
    }else{
        Q <- qmatHKY85(tmu,tv_ti_ratio,acgt)
        r  <- eigen(Q)
        B <- r$vectors
        E  <- diag(exp(r$values))

        #      Q        The eigen vector change of basis
        #  M  ->   M   
        #
        #  ^       ^
        #  |B^-1   |B
        #     Eig
        #  N  ->   N
        out <- solve(a=t(B),b= E %*% t(B))#Little trick to avoid numerical difficulties
        rownames(out) <- c("A","C","G","T")
        colnames(out) <- c("A","C","G","T")
        return(out) 
    } 
}

jukesCantorPmat <- function(tmu){
    #Using the Juke-Cantor model
    return(matrix(rep(1/4-exp(-tmu)/4,16),nrow=4,ncol=4,dimnames=list(c("A","C","G","T"),c("A","C","G","T")))+diag(rep(exp(-tmu),4)))
}

qmatHKY85 <- function(tmu,tv_ti,acgt){
    #HKY85 model
    #               |    sum_1         pi_c * tv_ti      pi_g           pi_t * tv_ti  |
    #               | pi_a * tv_ti     sum_2             pi_g * tv_ti   pi_t          |
    #  Q = tmu  *   |    pi_a          pi_c * tv_ti      sum_3          pi_t * tv_ti  |
    #               |    pi_a*tv_ti    pi_c              pi_g * tv_ti   sum_4         |
    #returns this matrix
    #This could be replaced with the analytical formulas for the substitutions probabilities.
    
    Qmat <- matrix(rep(acgt,4),ncol=4,byrow=TRUE)
    diag(Qmat) <- 0

    #Adjusting the transversions versus transitions
    #-  *  -  *    
    #*  -  *  -    
    #-  *  -  *    
    #*  -  *  -    

    Qmat[1,2] <- tv_ti*Qmat[1,2]
    Qmat[1,4] <- tv_ti*Qmat[1,4]

    Qmat[2,1] <- tv_ti*Qmat[2,1]
    Qmat[2,3] <- tv_ti*Qmat[2,3]
    
    Qmat[3,2] <- tv_ti*Qmat[3,2]
    Qmat[3,4] <- tv_ti*Qmat[3,4]

    Qmat[4,1] <- tv_ti*Qmat[4,1]
    Qmat[4,3] <- tv_ti*Qmat[4,3]

    diag(Qmat) <- -apply(Qmat,1,sum)

    Qmat <- tmu * Qmat 
    return(Qmat)
}

metroDesc <- function(lpr,lol){
    # the logic in the Metropolis-Hastings step 
    stopifnot(!is.na(lpr))
    stopifnot(!is.na(lol))
    if (log(runif(1))<lpr-lol){
        return(1)
    }else {
        return(0)
    }
}

genOverHang <- function(la){
    #Currently not used in the main code but could used to generate 
    #overhangs like Philip
    r <- runif(1)
    i <- -1
    p <- 0
    while (p< r){
        if (i==-1){
            term <- 1
        }else {
            term  <- 0
        }
        p <-p+ (la*((1-la)**(i+1))+term)/2
        i <- i+1
    }
    return(i)
}

sampleHJ <- function(x,size,prob){
    #Convenience function since sample wasn't good enough
    if (length(prob)==1){
        return(rep(x,size))
    }else {
        return(sample(x,size=size,prob=prob,replace=TRUE))
    }
}


seqProbVecLambda <- function(lambda,lambda_disp,m,fo_only=NA,re_only=NA){
    #Returns the position specific probability of being in an overhang
    if (is.na(fo_only) || is.na(re_only)){
        write("Must give parameters to fo_only or re_only",stderr())
        stop()
    }
    psum <- matrix(ncol=1,nrow=m)
    pvals <- dnbinom(c(1:m)-1,prob=lambda,size=lambda_disp)
    for (i in 1:m){
        psum[i,1] <- (1-sum(pvals[1:i]))/2
    }
    if (fo_only){
        #Only the forward part
        return(c(psum))
    }else if (re_only && fo_only){
        write("Shouldn't call this function with forward and reverse only.",stderr())
        stop()
    }else if (re_only) {
        #The reverse part
        return(rev(c(psum)))
    }else{
        #Both ends
        psum <- c(psum[1:(m/2),1],rev(psum[1:(m/2),1]))
        return(c(psum))
    }
}

#The following is an MC simulation code to mimic the 
#nick frequency part in the model from Philip
seqProbVecNuWithLengths<- cxxfunction( signature(
                                      I_la="numeric",
                                      I_la_disp="numeric",
                                      I_nu="numeric",
                                      I_m="numeric",
                                      I_lengths="numeric",
                                      I_mLe="numeric",
                                      I_fo="numeric",
                                      I_iter="numeric",
                                      I_ds_protocol="numeric"
                             ) ,includes='
                  #include <gsl/gsl_randist.h>
                  int genOverHang(double la,double la_disp)
                  {
                      double r = ((double) rand() / (RAND_MAX));
                      int i = -1;
                      double p = 0;
                      double term = -500; 
                      while (p<r){
                          if (i==-1){
                              term = 1;
                          }else {
                              term = 0;
                          }
                          p = p + (gsl_ran_negative_binomial_pdf(i+1,la,la_disp)+term)/2;
                          i++;
                      }
                      return(i);
                  }
                  ',body= '
              srand(time(0)); 
        Rcpp::NumericVector la(I_la);
        Rcpp::NumericVector la_disp(I_la_disp);
        Rcpp::NumericVector nu(I_nu);
        Rcpp::NumericVector m(I_m);
        Rcpp::NumericVector les(I_lengths);
        Rcpp::NumericVector mLe(I_mLe);
        Rcpp::NumericVector fo(I_fo);
        Rcpp::NumericVector iter(I_iter);
        Rcpp::NumericVector ds_protocol(I_ds_protocol);
//
        Rcpp::NumericVector output(mLe[0]);
        Rcpp::NumericVector reduced_output(m[0]);
        if (ds_protocol[0]==0){
            for (int j = 0; j < m[0];j++){
                reduced_output(j) = 1;
            }
            return(reduced_output);
        }else {
            for (int i = 0; i < iter[0];i++ ){
//
                double left_o_hang = genOverHang(la[0],la_disp[0]);
                double right_o_hang = genOverHang(la[0],la_disp[0]);
                double o_hang  = left_o_hang+right_o_hang;
//              
                if (o_hang>=les(i)){
                    //Single stranded sequence
                    for (int j = 0; j <les(i);j++){
                        output(j) = output(j)+1;
                    }
                } else {
                    Rcpp::NumericVector r = runif(1);
                    if (r[0]< (1-nu[0])/((les[i]-o_hang-1)*nu[0]+(1-nu[0]))){
                        for (int j = 0; j <(les[i]-right_o_hang);j++){
                            output(j) = output(j)+1;
                        }
                        //The right overhang is always G>A for the double stranded but 
                        //Here we will make the assumption that the pattern is symmetric 
                        //for practical reasons We can\'t  do that ....
                    }else {
                        Rcpp::NumericVector sa = floor(runif(1,0,les[i]-o_hang))+left_o_hang;
                        for (int j = 0; j <=sa[0];j++){
                            output(j) = output(j)+1;
                        }
                    }
                }
            }
            if (fo(0)){
                //Only considering the forward part
                for (int j = 0; j < m[0];j++){
                    reduced_output(j) = output(j)/iter(0);
                }
            }else {
                for (int j = 0; j < m[0]/2;j++){
                    reduced_output(j) = output(j)/iter(0);
                    reduced_output(m[0]-j-1) = 1-output(j)/iter(0);
                }
            }
            return(reduced_output);
        }
',plugin='RcppGSL' )




pDam <- function(th,ded,des,la,nu,lin){
    #The damage and mutation matrix multiplied together
    pct <- nu*(la*des+ded*(1-la))
    pga <- (1-nu)*(la*des+ded*(1-la))
    return(
           c(
             th[lin,1]*1+th[lin,3]*pga
             ,
             th[lin,2]*(1-pct)
             ,
             th[lin,3]*(1-pga)
             ,
             th[lin,2]*pct+th[lin,4]*1
             )
           )
}

logLikFunOneBaseSlow <- function(Gen,S,Theta,deltad,deltas,laVec,nuVec,m,lin){
    #Calculates the log likelihood using R, a C++ version is available  
    ll <- 0
    for (i in 1:length(laVec)){
        #Get the damage probabilities
        pd <- pDam(Theta,deltad,deltas,laVec[i],nuVec[i],lin)
        ll <- ll + dmultinom(S[i,],Gen[i],pd,log=TRUE)
    }
    return(ll)
}

#The same logic as in logLikFunOneBaseSlow except using a compiled code 
#to do the hard work
logLikFunOneBaseFast <- cxxfunction(signature(
                                      I_Gen="numeric",
                                      I_S="numeric",
                                      I_Theta="numeric",
                                      I_deltad="numeric",
                                      I_deltas="numeric",
                                      I_laVec="numeric",
                                      I_nuVec="numeric",
                                      I_m="numeric",
                                      I_lin="numeric"
                                      ), body = '
Rcpp::NumericMatrix S(I_S);
Rcpp::NumericMatrix th(I_Theta);

Rcpp::NumericVector Gen(I_Gen);

Rcpp::NumericVector Vded(I_deltad);
double ded = Vded[0];

Rcpp::NumericVector Vdes(I_deltas);
double des = Vdes[0];

Rcpp::NumericVector laVec(I_laVec);

Rcpp::NumericVector nuVec(I_nuVec);

Rcpp::NumericVector Vm(I_m);
int m = Vm[0];

Rcpp::NumericVector Vlin(I_lin);
int lin = Vlin[0];

Rcpp::NumericVector pDam(4);

Rcpp::NumericVector ret(1);
ret[0] = 0;

for (int i = 0; i<laVec.size();i++){
    double la = laVec[i];
    double nu = nuVec[i];
    double pct = nu*(la*des+ded*(1-la));
    double pga = (1-nu)*(la*des+ded*(1-la));
    pDam[0] = th(lin-1,0)*1+th(lin-1,2)*pga;
    pDam[1] = th(lin-1,1)*(1-pct);
    pDam[2] = th(lin-1,2)*(1-pga);
    pDam[3] = th(lin-1,1)*pct+th(lin-1,3)*1;
    double p1 = gsl_sf_lnfact(Gen(i))
               -gsl_sf_lnfact(S(i,0))
               -gsl_sf_lnfact(S(i,1))
               -gsl_sf_lnfact(S(i,2))
               -gsl_sf_lnfact(S(i,3));
    double p2 = S(i,0)*log(pDam[0])
               +S(i,1)*log(pDam[1])
               +S(i,2)*log(pDam[2])
               +S(i,3)*log(pDam[3]);
    ret[0] = ret[0] + p1 + p2;
}
return(ret);
', plugin="RcppGSL",include="#include <gsl/gsl_sf_gamma.h>")



logLikAll <- function(dat,Theta,deltad,deltas,laVec,nuVec,m){
    #Calculates the logLikelihood for all the bases by calling 
    # logLikFunOneBaseFast for each base
    if (deltad<0 || deltad>1 || deltas<0 || deltas>1  ){
        return(-Inf)
    }
    #A,C,G and T

    deb <- 0
    
    Asub <- dat[,"A.C"]+dat[,"A.G"]+dat[,"A.T"]    
    ALL <- logLikFunOneBaseFast(dat[,"A"],cbind(dat[,"A"]-Asub,dat[,"A.C"],dat[,"A.G"],dat[,"A.T"]),Theta,deltad,deltas,laVec,nuVec,m,1)
    if (deb){
        ALLSlow <- logLikFunOneBaseSlow(dat[,"A"],cbind(dat[,"A"]-Asub,dat[,"A.C"],dat[,"A.G"],dat[,"A.T"]),Theta,deltad,deltas,laVec,nuVec,m,1)
        stopifnot(all.equal(ALL,ALLSlow))
    }

    Csub <- dat[,"C.A"]+dat[,"C.G"]+dat[,"C.T"]
    CLL <- logLikFunOneBaseFast(dat[,"C"],cbind(dat[,"C.A"],dat[,"C"]-Csub,dat[,"C.G"],dat[,"C.T"]),Theta,deltad,deltas,laVec,nuVec,m,2)
    if (deb){
        CLLSlow <- logLikFunOneBaseSlow(dat[,"C"],cbind(dat[,"C.A"],dat[,"C"]-Csub,dat[,"C.G"],dat[,"C.T"]),Theta,deltad,deltas,laVec,nuVec,m,2)
        stopifnot(all.equal(CLL,CLLSlow))
    }
    

    Gsub <- dat[,"G.A"]+dat[,"G.C"]+dat[,"G.T"]
    GLL <- logLikFunOneBaseFast(dat[,"G"],cbind(dat[,"G.A"],dat[,"G.C"],dat[,"G"]-Gsub,dat[,"G.T"]),Theta,deltad,deltas,laVec,nuVec,m,3)
    if (deb){
        GLLSlow <- logLikFunOneBaseSlow(dat[,"G"],cbind(dat[,"G.A"],dat[,"G.C"],dat[,"G"]-Gsub,dat[,"G.T"]),Theta,deltad,deltas,laVec,nuVec,m,3)
        stopifnot(all.equal(CLL,CLLSlow))
    }
    
    Tsub <- dat[,"T.A"]+dat[,"T.C"]+dat[,"T.G"]
    TLL <- logLikFunOneBaseFast(dat[,"T"],cbind(dat[,"T.A"],dat[,"T.C"],dat[,"T.G"],dat[,"T"]-Tsub),Theta,deltad,deltas,laVec,nuVec,m,4)
    if (deb){
        TLLSlow <- logLikFunOneBaseSlow(dat[,"T"],cbind(dat[,"T.A"],dat[,"T.C"],dat[,"T.G"],dat[,"T"]-Tsub),Theta,deltad,deltas,laVec,nuVec,m,4)
        stopifnot(all.equal(TLL,TLLSlow))
    }
    return(ALL+CLL+GLL+TLL)
}


getParams <- function(cp){
    #Utility function nice to update the MCMC iterations matrix 
    return(c(cp$Theta,cp$Rho,cp$DeltaD,cp$DeltaS,cp$Lambda,cp$LambdaRight,cp$LambdaDisp,cp$Nu))
}

plotTrace<- function(dat,main,k=111){
    #Running median of the MCMC iterations
    plot(1:length(dat),dat,xlab="Iteration",ylab="",main=main,type="l")
}

plotEverything <- function(mcmcOut,hi=0,pl,thin=100){
    #Plots the MCMC traceplot in the form of a running median and 
    #histogram of the MCMC iterations
    if (sum(c(cu_pa$same_overhangs==FALSE,
                    cu_pa$fix_disp==FALSE,
                    cu_pa$fix_ti_tv==FALSE,
                    cu_pa$nuSamples!=0))>1){
        #Check if I need to add a extra row
        a_extra_row <- 1
    }else {
        a_extra_row <- 0
    }
    par(mfrow=c(3,2+a_extra_row))
    if(hi){
        hist(mcmcOut$out[,"Theta"],main=expression(theta),xlab="",freq=FALSE)
        if (!mcmcOut$cu_pa$fix_ti_tv){
            hist(mcmcOut$out[,"Rho"],main=expression(rho),xlab="",freq=FALSE)
        }
        hist(mcmcOut$out[,"DeltaD"],main=expression(delta[d]),xlab="",freq=FALSE)
        hist(mcmcOut$out[,"DeltaS"],main=expression(delta[s]),xlab="",freq=FALSE)
        hist(mcmcOut$out[,"Lambda"],main=expression(lambda),xlab="",freq=FALSE)
        if (!mcmcOut$cu_pa$same_overhangs){
            hist(mcmcOut$out[,"LambdaRight"],main=expression(lambda[r]),xlab="",freq=FALSE)
        }
        if (!mcmcOut$cu_pa$fix_disp){
            hist(mcmcOut$out[,"LambdaDisp"],main=expression(sigma[lambda]),xlab="",freq=FALSE)
        }
        if (mcmcOut$cu_pa$nuSamples!=0){
            hist(mcmcOut$out[,"Nu"],main=expression(nu),xlab="",freq=FALSE)
        }
        hist(mcmcOut$out[,"LogLik"],main="LogLik",xlab="",freq=FALSE)
    }else {
        plotTrace(mcmcOut$out[,"Theta"],main=expression(theta))
        if (!mcmcOut$cu_pa$fix_ti_tv){
            plotTrace(mcmcOut$out[,"Rho"],main=expression(theta))
        }
        plotTrace(mcmcOut$out[,"DeltaD"],main=expression(delta[d]))
        plotTrace(mcmcOut$out[,"DeltaS"],main=expression(delta[s]))
        plotTrace(mcmcOut$out[,"Lambda"],main=expression(lambda))
        if (!mcmcOut$cu_pa$same_overhangs){
            plotTrace(mcmcOut$out[,"LambdaRight"],main=expression(lambda[r]))
        }
        if (!mcmcOut$cu_pa$fix_disp){
            plotTrace(mcmcOut$out[,"LambdaDisp"],main=expression(sigma[lambda]))
        }
        if (mcmcOut$cu_pa$nuSamples!=0){
            plotTrace(mcmcOut$out[,"Nu"],main=expression(nu))
        }
        plotTrace(mcmcOut$out[,"LogLik"],main="LogLik")
    }
    par(mfrow=c(1,1))
}

accRat <- function(da){
    #A rough measure of the acceptance ratio 
    return(length(unique(da))/length(da))
}

adjustPropVar <- function(mcmc,propVar){
    #Adjust the proposal variance to get something near .22
    for (i in colnames(mcmc$out)){
        if (i=="LogLik"){
            next
        } else if (i=="LambdaRight" & mcmc$cu_pa$same_overhangs){
            next
        } else if (i=="Nu" & mcmc$cu_pa$nuSamples==0){
            next
        } else if (i=="LambdaDisp" & mcmc$cu_pa$fix_disp){
            next
        } else if (i=="Rho" & mcmc$cu_pa$fix_ti_tv){
            next
        }
        rat <- accRat(mcmc$out[,i])
        if (rat<0.1){
            propVar[[i]] <- propVar[[i]]/2
        } else if (rat>0.3) {
            propVar[[i]] <- propVar[[i]]*2
        }
    }
    return(propVar)
}

runGibbs <- function(cu_pa,iter){
    #Sampling over the conditional posterior distribution 
    #for the parameters.
    esti <- matrix(nrow=iter,ncol=9)
    colnames(esti) <- c("Theta","Rho","DeltaD","DeltaS","Lambda","LambdaRight","LambdaDisp","Nu","LogLik")
    for (i in 1:iter){
        cu_pa<-updateTheta(cu_pa)
        if (!cu_pa$fix_ti_tv){
            #Fix the transition and transversion ratio
            cu_pa<-updateRho(cu_pa)
        }
        cu_pa<-updateDeltaD(cu_pa)
        cu_pa<-updateDeltaS(cu_pa)
        cu_pa<-updateLambda(cu_pa)
        if (!cu_pa$same_overhangs){
            #Not the same overhangs update lambda right
            cu_pa <- updateLambdaRight(cu_pa)
        }
        if (!cu_pa$fix_disp){
            #Allowing dispersion in the overhangs
            cu_pa<-updateLambdaDisp(cu_pa)
        }
        if (cu_pa$nuSamples!=0){
            #Update the nu parameter by via MC estimation
            cu_pa<-updateNu(cu_pa)
        }
        esti[i,c(1:8)] <- getParams(cu_pa) 
        esti[i,"LogLik"] <- logLikAll(cu_pa$dat,cu_pa$ThetaMat,cu_pa$DeltaD,cu_pa$DeltaS,cu_pa$laVec,cu_pa$nuVec,cu_pa$m)
        if (! (i %% 1000) && cu_pa$verbose){
            cat("MCMC-Iter\t",i,"\t",esti[i,"LogLik"],"\n")
        }
    }
    return(list(out=esti,cu_pa=cu_pa))
}


simPredCheck <- function(da,output){
    #Simulates one draw from the posterior predictive distribution
    #and the probability of a C>T substitution because of a cytosine 
    #demnation.
    bases <- da[,c("A","C","G","T")]
    #Constructing the lambda vector
    if (output$cu_pa$same_overhangs){
        laVec <- seqProbVecLambda(sample(output$out[,"Lambda"],1),
                                  sample(output$out[,"LambdaDisp"],1),
                                  output$cu_pa$m,
                                  output$cu_pa$forward_only,
                                  cu_pa$reverse_only)
    }else {
        laVecLeft <- seqProbVecLambda(sample(output$out[,"Lambda"],1),
                                      sample(output$out[,"LambdaDisp"],1),
                                      output$cu_pa$m,
                                      0,
                                      0)
        laVecRight <- seqProbVecLambda(sample(output$out[,"LambdaRight"],1),
                                       sample(output$out[,"LambdaDisp"],1),
                                       output$cu_pa$m,
                                       0,
                                       0)
        laVec <- c(laVecLeft[1:(output$cu_pa$m/2)],laVecRight[(output$cu_pa$m/2+1):output$cu_pa$m])
    }
    #Constructing the nu vector
    if (output$cu_pa$nuSamples !=0){
        write("The MC sampling for the nu vector hasn't gone through a extensive testing procedure",stderr())
        stop()
        nuVec <- seqProbVecNuWithLengths(sample(output$out[,"Lambda"],1),
                                         sample(output$out[,"LambdaDisp"],1),
                                         sample(output$out[,"Nu"],1),
                                         nrow(cu_pa$dat),
                                         sampleHJ(output$cu_pa$lengths$Length,
                                                 size=output$cu_pa$laSamples,
                                                 prob=output$cu_pa$lengths$Occurences),
                                         output$cu_pa$mLe,
                                         output$cu_pa$forward_only,
                                         output$cu_pa$nuSamples,
                                         output$cu_pa$ds_protocol) 
        nuVec <- c(nuVec,rev(1-nuVec))
    }else {
        nuVec <- output$cu_pa$nuVec
    }
    
    #Sample the other parameters
    des <- sample(output$out[,"DeltaS"],1)
    ded <- sample(output$out[,"DeltaD"],1)
    the <- sample(output$out[,"Theta"],1)
    rho <- sample(output$out[,"Rho"],1)
    pmat <- getPmat(the,rho,output$cu_pa$acgt)
    ptransCT <- pmat["C","T"]
    ptransCC <- pmat["C","C"]
    ptransGA <- pmat["G","A"]
    ptransGG <- pmat["G","G"]
    #
    coln <- c("A.C","A.G","A.T","C.A","C.G","C.T","G.A","G.C","G.T","T.A","T.C","T.G")
    subs <- matrix(NA,nrow=nrow(output$cu_pa$dat),ncol=4+length(coln))
    colnames(subs) <- c("A","C","G","T",coln)
    #
    damProb <- rep(NA,nrow(output$cu_pa$dat)) 
    damProbGA <- damProb 
    for (i in 1:nrow(output$cu_pa$dat)){
        #Construct the site specific probabilities 
        pct <- nuVec[i]*(laVec[i]*des+ded*(1-laVec[i]))
        pga <- (1-nuVec[i])*(laVec[i]*des+ded*(1-laVec[i]))
        pDamMat <- matrix(c(
                         1,0,0,0,
                         0,1-pct,0,pct,
                         pga,0,1-pga,0,
                         0,0,0,1
                         ),nrow=4,byrow=TRUE)
        ThetapDam <- pDamMat %*% pmat 
        #Calculate the probability C.T due to cytosine demanation
        damProb[i] <- ptransCC*pct/(ptransCC*pct+ptransCT) 
        #Do not forget the reverse complement 
        damProbGA[i] <- ptransGG*pga/(ptransGG*pga+ptransGA) 
        #Then draw from a multinomial distribution
        subs[i,c("A.C","A.G","A.T")] <- t(rmultinom(1,output$cu_pa$dat[i,"A"],ThetapDam[1,]))[-1]/output$cu_pa$dat[i,"A"]
        subs[i,c("C.A","C.G","C.T")] <- t(rmultinom(1,output$cu_pa$dat[i,"C"],ThetapDam[2,]))[-2]/output$cu_pa$dat[i,"C"]
        subs[i,c("G.A","G.C","G.T")] <- t(rmultinom(1,output$cu_pa$dat[i,"G"],ThetapDam[3,]))[-3]/output$cu_pa$dat[i,"G"]
        subs[i,c("T.A","T.C","T.G")] <- t(rmultinom(1,output$cu_pa$dat[i,"T"],ThetapDam[4,]))[-4]/output$cu_pa$dat[i,"T"]
    }
    return(list(subs=subs,damProb=damProb,damProbGA=damProbGA))
}

calcSampleStats <- function(da,X){
    #Summary statistics of the posterior distributions
    return(data.frame(
                      x=1:nrow(da),
                      pos=da[,"Pos"],
                      mea=apply(X,1,mean),
                      med=apply(X,1,median),
                      loCI=apply(X,1,quantile,c(0.025)),
                      hiCI=apply(X,1,quantile,c(0.975))
                      ))
}

postPredCheck <- function(da,output,samples=10000){
    #Plots the 95% posterior predictive intervals with the data as lines.
    #Returns the site specific probability of a C>T or G>A substitution 
    #because of a cytosine demnation.
    CTs <- matrix(NA,nrow=nrow(da),ncol=samples)
    GAs <- matrix(NA,nrow=nrow(da),ncol=samples)
    REs <- matrix(NA,nrow=nrow(da),ncol=samples)
    C2TProbs <- matrix(NA,nrow=nrow(da),ncol=samples)
    G2AProbs <- matrix(NA,nrow=nrow(da),ncol=samples)
    #Two indices here, 1-based and the relative one
    da <- cbind(1:(nrow(da)),da)
    colnames(da)[1] <- "oneBased"
    #Get the breaks depending on parameters for pretty plots
    if (!output$cu_pa$forward_only || !output$cu_pa$reverse_only){
        bres <- c(seq(from=1,to=floor(nrow(da)/2),by=2),rev(seq(from=nrow(dat),to=floor(nrow(da)/2)+1,by=-2)))
    }else if (output$cu_pa$forward_only) {
        bres <- seq(from=1,to=nrow(da),by=2)
    } else if (output$cu_pa$reverse_only){
        bres <- seq(from=nrow(dat),to=1,by=-2)
    }else {
        write("There is something fishy with the options",stderr())
        stop()
    }
    labs <- dat[bres,"Pos"]
    #Sample from the posterior predicitive distibution
    for (i in 1:samples){
        sam <- simPredCheck(da,output)
        C2TProbs[,i] <- sam$damProb
        G2AProbs[,i] <- sam$damProbGA
        CTs[,i] <- sam$subs[,"C.T"]
        GAs[,i] <- sam$subs[,"G.A"]
        REs[,i] <- apply(sam$subs[,c("A.C","A.G","A.T","C.A","C.G","G.C","G.T","T.A","T.C","T.G")],1,mean)
    }
    CTsStats <- calcSampleStats(da,CTs)
    GAsStats <- calcSampleStats(da,GAs)
    REsStats <- calcSampleStats(da,REs) 
    #Plotting the posterior predictive intervals
    p <- ggplot()+
         geom_point(aes(x,mea,colour="C->T",aes_string="subs"),data=CTsStats)+
         geom_point(aes(x,mea,colour="G->A"),data=GAsStats)+
         geom_point(aes(x,mea,colour="Others"),data=REsStats)+
         geom_errorbar(aes(x=x,y=med,ymin=loCI,ymax=hiCI,color="C->T"),data=CTsStats)+
         geom_errorbar(aes(x=x,y=med,ymin=loCI,ymax=hiCI,color="G->A"),data=GAsStats)+
         geom_errorbar(aes(x=x,y=med,ymin=loCI,ymax=hiCI,color="Others"),data=REsStats)+
         geom_line(aes(oneBased,C.T/C),color="red",data=data.frame(da))+
         geom_line(aes(oneBased,G.A/G),color="green",data=data.frame(da))+
         geom_line(aes(oneBased,((A.C+A.G+A.T)/A+(C.A+C.G)/C+(G.C+G.T)/G+(T.A+T.C+T.G)/T)/10),color="blue",data=data.frame(da))+
         ylab("Substitution rate")+
         xlab("Relative position")+
         scale_x_continuous(breaks=bres,labels=labs)+
         labs(colour = "Subs. type")+
         ggtitle("Posterior prediction intervals")
    if (output$cu_pa$use_bw_theme){
        p <- p+theme_bw()
    }
    plot(p)
    #The correcting probabilities 
    coProbs <- cbind(da[,"Pos"],apply(C2TProbs,1,mean),apply(G2AProbs,1,mean))
    colnames(coProbs) <- c("Position","C.T","G.A")
    return(coProbs)
}


writeMCMC <- function(out,filename){
    #Writes the posterior samples to a file
    parameters <- c("Theta","DeltaD","DeltaS","Lambda")
    if (!out$cu_pa$fix_ti_tv){
        parameters <- c(parameters,"Rho")
    }
    if (!out$cu_pa$same_overhangs){
        parameters <- c(parameters,"LambdaRight")
    }
    if (!out$cu_pa$fix_disp){
        parameters <- c(parameters,"LambdaDisp")
    }
    if (out$cu_pa$nuSamples!=0){
        parameters <- c(parameters,"Nu")
    }
    parameters <- c(parameters,"LogLik")
    write.csv(out$out[,parameters],paste(filename,".csv",sep=""))
    #Now calculate summary statistic of the posterior distributions
    mea <- apply(out$out[,parameters],2,mean)
    std <- apply(out$out[,parameters],2,sd)
    qua <- apply(out$out[,parameters],2,quantile,seq(from=0,to=1,by=.025))
    acc <- apply(out$out[,parameters],2,accRat)
    summStat <- rbind(mea,std,acc,qua)
    rownames(summStat)[1] <- "Mean" 
    rownames(summStat)[2] <- "Std." 
    rownames(summStat)[3] <- "Acceptance ratio" 
    write.csv(summStat,paste(filename,"_summ_stat.csv",sep=""))
}

# R script mapdamage
# Enable full backtraces on errors
on_error <- function(e)
  {
    traceback(2)
    quit(status = 1)
  }
options(error = on_error)


NUCLEOTIDES <- c("A", "C", "G", "T", "Total")
MISMATCHES  <- c("A>C", "A>G", "A>T", "C>A", "C>G", "C>T", "G>A", "G>C", "G>T", "T>A", "T>C", "T>G")
INSERTIONS  <- c("->A", "->C", "->G", "->T")
DELETIONS   <- c("A>-", "C>-", "G>-", "T>-")
CLIPPING    <- c("S")
EVERYTHING  <- c(NUCLEOTIDES, MISMATCHES, INSERTIONS, DELETIONS, CLIPPING)

args <- commandArgs(trailingOnly = TRUE)
OPT.COMP      <- args[1]
OPT.PDFOUT    <- args[2]
OPT.AROUND    <- as.numeric(args[3])
OPT.MISINCORP <- args[4]
OPT.LENGTH    <- as.numeric(args[5])
OPT.YMAX      <- as.numeric(args[6])
OPT.FOLDER    <- args[7]
OPT.TITLE     <- args[8]
OPT.VERSION   <- args[9]


draw.open.rect <- function(xleft, ybottom, xright, ytop, padding = 0) {
  if (xleft < 0) {
    xpoints <- c(xleft, xright + padding, xright + padding, xleft)
  } else {
    xpoints <- c(xright, xleft - padding, xleft - padding, xright)
  }
    
  lines(xpoints, c(ytop, ytop, ybottom, ybottom), col = "darkgrey")
}


plot.base.composition <- function(tbl, base, color, around, ylabels.at = c(), xlabels = FALSE) {
  xcoords <- c(-around:-1, 1:around)
  
  plot.axis <- function(yaxis.at) {
    axis(side = yaxis.at, labels = (yaxis.at == ylabels.at), line = 0, las = 2, cex.axis = 0.8)
    if ((yaxis.at == 2) && (yaxis.at == ylabels.at)) {
      mtext("Frequency", side = 2, line = 2.5, cex = 0.6)
    }
  
    if (xlabels) {
      axis(side = 1, labels = xcoords, at = xcoords, las = 2, cex.axis = 0.6)
    } else {
      axis(side = 1, labels = FALSE,   at = xcoords)
    }
  }

  plot.frequencies <- function(end) {
    subtbl <- subset(tbl, End == end)
    plot(subtbl$Pos, subtbl[, base] / subtbl$Total, pch = '.',
       xlim = c(-around, around), ylim = c(0, 0.5),
       col = color, main = base, cex.axis = 0.8, las = 2,
       xlab = "", ylab = "", lab = c(2 * around, 6, 0.2),
       axes = FALSE)

    ycoords <- NULL
    for (i in xcoords) {
      ycoords <- append(ycoords, mean(subtbl[(subtbl$Pos==i), base]/subtbl$Total[(subtbl$Pos==i)],na.rm=T)) 
    }
    points(xcoords, ycoords, pch = 20, col = color, type = "b")
  }

  # 5p end
  par(mar = c(1, 2, 1, 0.25))
  plot.frequencies("5p")
  plot.axis(2)
  draw.open.rect(0, 0, around, 0.5)

  # 3p end
  par(mar = c(1, 0.25, 1, 2))
  plot.frequencies("3p")
  plot.axis(4)
  draw.open.rect(-around, 0, 0, 0.5)
  
  par(mar = c(1, 2, 1, 2))
}


calculate.mutation.table <- function(filename, length)
  {
    tbl <- read.table(file = filename, sep = "\t", header = TRUE, check.names = FALSE)
    tbl <- aggregate(tbl[, EVERYTHING], tbl[, c("End", "Pos")], sum)
    for (mismatch in MISMATCHES) {
      tbl[, mismatch] <- tbl[, mismatch] / tbl[, substr(mismatch, 1, 1)]
    }

    for (mismatch in c(INSERTIONS, DELETIONS, CLIPPING)) {
      tbl[, mismatch] <- tbl[, mismatch] / tbl[, "Total"]
    }

    return(tbl[tbl$Pos <= length, ])
  }


write.mutation.table <- function(tbl, end, mismatch, filename)
  {
    columns <- c("pos", sprintf("5p%s", mismatch))
    tbl[is.na(tbl)] <- 0 # Python doesn't like NAs  
    write.table(tbl[tbl$End == end, c("Pos", mismatch)],
                row.names = FALSE, col.names = columns,
                sep = "\t", quote = FALSE,
                file = filename)
  }


plot.mutations <- function(end, axis.at, start.i, end.i, modifier) {
  do.plot <- function(tbl, end, modifier, mismatches, color, width) {
    subtable <- tbl[tbl$End == end, c("Pos", mismatches)]
    rates    <- rowSums(subtable) - subtable$Pos
    subtable <- aggregate(list(Rate = rates), list(Pos = subtable$Pos), sum)
    
    lines(subtable$Pos * modifier, subtable$Rate,
          xlim = c(1, OPT.LENGTH), ylim = c(0, OPT.YMAX),
          col = color, lwd = width)
  }
  
  plot(NA, xlim = c(start.i, end.i), ylim=c(0, OPT.YMAX), col="grey", lwd = 1, type = "l", xlab = "", ylab = "", axes = FALSE)
  axis(side = 1, labels = start.i:end.i, at = start.i:end.i, las = 2, cex.axis = 0.8)
  axis(side = axis.at, labels = TRUE, las = 2, cex.axis = 0.8)
  if (end == "5p") {
      mtext("Frequency", side = 2, line = 2.5, cex = 0.6)
  }
  draw.open.rect(start.i, OPT.YMAX, end.i, -0.01, padding = 0.5)
  
  for (mismatch in MISMATCHES) {
    do.plot(mut, end, modifier, mismatch, "grey", 1)
  }
  
  do.plot(mut, end, modifier, CLIPPING,   "orange", 1)
  do.plot(mut, end, modifier, DELETIONS,  "green", 1)
  do.plot(mut, end, modifier, INSERTIONS, "purple", 1)
  do.plot(mut, end, modifier, "G>A",      "blue", 2)
  do.plot(mut, end, modifier, "C>T",      "red", 2)
}


pdf(file = OPT.PDFOUT, title = paste("mapDamage-", OPT.VERSION, " plot"))
par(oma = c(4,2,2,2), mar = c(1,2,1,2))
layout(matrix(c(1,1,   1,1,    # Title
                2,3,   4,5,    # A,  C
                6,7,   8,9,    # G,  T
                10,10, 11,11), # Mismatches 5p, 3p
              4, 4, byrow = TRUE),
       heights = c(3, 20, 20, 20))

# Plot title
plot(0, type = "n", xaxt = "n", yaxt = "n", bty = "n", xlab = "", ylab = "")
mtext(OPT.TITLE, 3, cex = 1.3)

# Base compositions
com <- read.table(file = OPT.COMP, sep = "\t", header = TRUE, as.is = TRUE)
plot.base.composition(com, "A", "blue",  OPT.AROUND, xlabels = FALSE, ylabels.at = c(2, 4))
plot.base.composition(com, "C", "green", OPT.AROUND, xlabels = FALSE, ylabels.at = c(4))
plot.base.composition(com, "G", "black", OPT.AROUND, xlabels = TRUE,  ylabels.at = c(2, 4))
plot.base.composition(com, "T", "red",   OPT.AROUND, xlabels = TRUE,  ylabels.at = c(4))


# Misincorporation patterns
mut <- calculate.mutation.table(OPT.MISINCORP, OPT.LENGTH)
# Write table of post-morten damage frequencies to tables
write.mutation.table(mut, "5p", "C>T", paste(OPT.FOLDER, "/5pCtoT_freq.txt", sep = ""))
write.mutation.table(mut, "3p", "G>A", paste(OPT.FOLDER, "/3pGtoA_freq.txt", sep = ""))

par(mar = c(1, 2, 1, 1))
plot.mutations("5p", 2, 1, OPT.LENGTH, 1)

par(mar = c(1, 1, 1, 2))
plot.mutations("3p", 4, -OPT.LENGTH, -1, -1)

# graphics.off() calls dev.off() for all devices but doesn't return anything (avoid null device message)
graphics.off()

#!/usr/bin/Rscript
#Simple script to check if the necessary packages are installed.
args <- commandArgs(TRUE)
whichProgram = args[2]

if (whichProgram=="inline"){
    library(inline)
} else if (whichProgram=="ggplot2"){
    library(ggplot2)
} else if (whichProgram=="Rcpp"){
    library(Rcpp)
} else if  (whichProgram=="gam"){
    library(gam) 
} else if  (whichProgram=="RcppGSL"){
    library(RcppGSL)
} else {
    stop(paste("Error in checkLibraries.R, no need to check this library",whichProgram))
}

#Functions to load the raw data
sumTheChr <- function(da,co){
    #Sum up the columns for the different chromosomes
    return(tapply(da[[co]],da$Pos,sum))
}

readMapDamData <- function(folder,forward=1){
    #Reads in the data from mapdamage
    #Sums up the position counts for the different chromosomes
    fil <- "misincorporation.txt"
    raw_dat <- read.table(paste(folder,fil,sep=""),header=TRUE)
    if (forward==1){
        raw_dat_plus <- raw_dat[raw_dat$End=="5p" & raw_dat$Std=="+",] 
        raw_dat_minus <- raw_dat[raw_dat$End=="5p" & raw_dat$Std=="-",]
    } else {
        raw_dat_plus <- raw_dat[raw_dat$End=="3p" & raw_dat$Std=="+",]
        raw_dat_minus <- raw_dat[raw_dat$End=="3p" & raw_dat$Std=="-",] 
    }
    dat <- matrix(nrow=max(raw_dat_plus$Pos),ncol=length(colnames(raw_dat_plus))-3)
    colnames(dat) <- colnames(raw_dat_plus)[c(-1,-2,-3)]
    dat[,"Pos"] <- seq(from=1,to=nrow(dat),by=1)
    if (forward!=1){
        dat[,"Pos"] <- - dat[,"Pos"]
    }
    for (i in colnames(raw_dat)[c(-1,-2,-3,-4)]){
        dat[,i] <- sumTheChr(raw_dat_plus,i)+sumTheChr(raw_dat_minus,i)
    }
    return(dat)
}

joinFowAndRev <- function(fo,re,nrPos){
    #Joins the 5' and 3' end with nrPos bases for each end
    te <- fo[1:nrPos,]
    te2 <- re[nrPos:1,]
    out <- rbind(te,te2)
    out[,"Pos"] <- c(1:nrPos,-c(nrPos:1))
    return(out)
}

getSeqLen <- function(pa){
    #Path to the mapDamage folder to get the length distribution
    le_dat_min <- read.table(paste(pa,"lengthDistribStrd-.txt",sep=""),header=TRUE)
    le_dat_plu <- read.table(paste(pa,"lengthDistribStrd+.txt",sep=""),header=TRUE)
    les <- list(Length=le_dat_min$Length,Occurences=le_dat_min$Occurences+le_dat_plu$Occurences)
    les$Length <- les$Length[les$Occurences!=0]
    les$Occurences <- les$Occurences[les$Occurences!=0]/sum(les$Occurences)
    return(les)
}

readBaseFreqs <- function(fol){
    #Get the nucleotide composition of the genome
    fil <- "dnacomp_genome.csv"
    dat <- read.csv(paste(fol,fil,sep=""),header=TRUE)
    return(c(dat$A,dat$C,dat$G,dat$T))
}

# Enable full backtraces on errors
on_error <- function(e)
  {
    traceback(2)
    quit(status = 1)
  }
options(error = on_error)


args <- commandArgs(trailingOnly = TRUE)
OPT.LGDIST    <- args[1]
OPT.PDFOUT    <- args[2]
OPT.MISINCORP <- args[3]
OPT.LENGTH    <- args[4]
OPT.TITLE     <- args[5]
OPT.VERSION   <- args[6]
OPT.QUIET     <- args[7]

MISMATCHES  <- c("C>T", "G>A")

calculate.mutation.table <- function(filename){

    tbl <- read.table(file = filename, sep = "\t", header = TRUE, check.names = FALSE)
    tbl <- aggregate(tbl[, MISMATCHES], tbl[, c("End", "Std", "Pos")], sum)
    return(tbl)
}


plot.length <- function(tbl, title, color) {
    table <- aggregate(tbl$Occurences, by=list(tbl$Length), FUN=sum)
    names(table)<- c("Length", "Occurences")
    plot(table$Length, table$Occurences, type="h",
       col = color, main = title, cex.axis = 0.8, las = 2,
       xlab = "", ylab = "", axes = FALSE)
 
    mtext("Occurences", side = 2, line = 2.5, cex = 0.7)
    mtext("Read length", side = 1, line = 2, cex = 0.7)
    xcoord = seq(min(table$Length), max(table$Length), 10)
    axis(side = 1, labels = xcoord, at = xcoord, las = 2, cex.axis = 0.6)
    axis(side = 2, labels = TRUE, las = 2, cex.axis = 0.6)
}

plot.lengthStd <- function(tbl, title) {
    subplus = subset(tbl, Std == "+")
    subminus = subset(tbl, Std == "-")
    plot(subplus$Length, subplus$Occurences, type="h", col=rgb(1,0,0,1/2), main = title, axes = FALSE)
    lines(subminus$Length, subminus$Occurences, type="h", col=rgb(0,0,1,1/2))
    mtext("Occurences", side = 4, line = 2.5, cex = 0.7)
    mtext("Read length", side = 1, line = 2, cex = 0.7)
    xcoord = seq(min(subplus$Length), max(subplus$Length), 10)
    axis(side = 1, labels = xcoord, at = xcoord, las = 2, cex.axis = 0.6)
    axis(side = 4, labels = TRUE, las = 2, cex.axis = 0.6)
    legend('topright',c('+ strand','- strand'),
       fill = rgb(1:0,0,0:1,0.4), bty = 'n',
       border = NA)
}

plot.cumul.mutation <- function(tbl, end, mut, sid) {
    subplus = subset(tbl, Std == "+" & End == end)
    subminus = subset(tbl, Std == "-" & End == end)
    plot(c(0, cumsum(subplus[, mut]/sum(subplus[, mut]))), 
	 type = "l", col = rgb(1,0,0,1/2), lwd = 2, axes = FALSE)
    lines(c(0, cumsum(subminus[, mut]/sum(subminus[, mut]))), 
	 col = rgb(0,0,1,1/2), lwd = 2)
    axis(side = 1, labels = TRUE, las = 2, cex.axis = 0.6)
    axis(side = sid, labels = seq(0,1,0.1), at = seq(0,1,0.1), las = 2, cex.axis = 0.6)
    mtext(mut, side = 3, line = 2, cex = 0.8)
    mtext("Read position", side = 1, line = 1.8, cex = 0.7)
    mtext("Cumulative frequencies", side = sid, line = 2.5, cex = 0.7)
    legend('topleft',c('+ strand','- strand'),
       	  fill = rgb(1:0,0,0:1,0.4), bty = 'n',
          border = NA)
}

lg <- read.table(file = OPT.LGDIST, sep = "\t", header = TRUE, as.is = TRUE)
if(nrow(lg) == 0){
    write("No length distributions are available, plotting length distribution only works for single-end reads", stderr())
}else{

    pdf(file = OPT.PDFOUT, title = paste("mapDamage-", OPT.VERSION, sep=""))
    par(oma = c(4,2,2,2), mar = c(1,2,1,2))
    layout(matrix(c(1,1,  # Title
                    2,3,  # lengths
                    4,5), # Cumulative mutation
                    3, 2, byrow = TRUE),
           heights = c(3, 20, 20))
    
    # Plot title
    plot(0, type = "n", xaxt = "n", yaxt = "n", bty = "n", xlab = "", ylab = "")
    mtext(OPT.TITLE, 3, cex = 1.3)
    
    # Base compositions
    plot.length(lg, "Single-end read length distribution", "black")
    plot.lengthStd(lg, "Single-end read length per strand")
    
    # Misincorporation patterns
    mut <- calculate.mutation.table(OPT.MISINCORP)
    
    par(mar = c(1, 2, 7, 1))
    plot.cumul.mutation(mut, "5p", "C>T", 2)
    par(mar = c(1, 1, 7, 2))
    plot.cumul.mutation(mut, "3p", "G>A", 4)
    
    # graphics.off() calls dev.off() for all devices but doesn't return anything (avoid null device message)
    graphics.off()
    if(OPT.QUIET == 0){
        cat(paste("additional", OPT.PDFOUT, "generated\n"))
    }
}

#The main work flow of the package
#Load the libraries
suppressMessages(library(inline))  #Already checked the libraries 
suppressMessages(library(ggplot2)) #thus ignoring any messages from them
suppressMessages(library(Rcpp))
suppressMessages(library(gam)) 
suppressMessages(library(RcppGSL))

#Miscellaneous functions 
source(paste(path_to_mapDamage_stats,"function.R",sep=""))

#Prior and proposal distributions for the parameters
source(paste(path_to_mapDamage_stats,"priorPropose.R",sep=""))

#Update functions for the gibbs sampler
source(paste(path_to_mapDamage_stats,"postConditonal.R",sep=""))

#functions for the grid search
source(paste(path_to_mapDamage_stats,"start.R",sep=""))

#functions for loading the data 
source(paste(path_to_mapDamage_stats,"data.R",sep=""))


#######################################################
#
#              Loading the data
#
#######################################################

#This used for the Briggs MC estimation
if (nu_samples!=0){
    start_vals$lengths <- getSeqLen(path_to_dat)
    start_vals$le  <- floor(weighted.mean(x=start_vals$lengths$Length,w=start_vals$lengths$Occurences))
}

if (forward_only && reverse_only){
    write("Cannot specify using only the 5' end and the 3' end which makes no sense",stderr())
    stop()
}

fow_dat <-readMapDamData(path_to_dat) 
rev_dat <-readMapDamData(path_to_dat,forward=0)
if (forward_only){
    #Taking only the forward part
    dat <- fow_dat[1:sub_length,] 
}else if (reverse_only){
    #Taking only the reverse part
    dat <- rev_dat[sub_length:1,] 
}else {
    #Using both ends
    dat <- joinFowAndRev(fow_dat,rev_dat,sub_length)
}

#Getting everything ready for the mutation model
if (jukes_cantor){
    acgt <- c(0.25,0.25,0.25,0.25)
    fix_ti_tv <- TRUE
}else {
    acgt <- readBaseFreqs(path_to_dat)
    fix_ti_tv <- FALSE
}

#A list that keeps everything between the iterations
cu_pa <- list(
              dat=dat,
              ThetaMat=NA,
              Theta=-log((-start_vals$ptrans+.25)*4),
              Rho=start_vals$rho,
              DeltaD=start_vals$deltad,
              DeltaS=start_vals$deltas,
              Lambda=start_vals$lambda,
              LambdaRight=start_vals$lambda_right,
              LambdaDisp=start_vals$lambda_disp,
              Nu=start_vals$nu,
              m=nrow(dat),
              meanLength=NA,
              lengths=NA,
              mLe=NA,
              laVec=NA,
              nuVec=NA,
              iter=iterations,
              nuSamples=nu_samples,
              fix_nu=fix_nu,
              ds_protocol=ds_protocol,
              forward_only=forward_only,
              reverse_only=reverse_only,
              fix_disp= fix_disp,
              same_overhangs= same_overhangs,
              fix_ti_tv = fix_ti_tv,
              acgt = acgt,
              old_lik=-Inf,
              verbose=verbose,
              quiet=quiet,
              use_raw_nick_freq = use_raw_nick_freq,
              use_bw_theme = use_bw_theme
              )

if (nu_samples!=0){
    #Need the lengths for the Briggs MC estimation
    cu_pa$meanLength <- start_vals$le
    cu_pa$lengths  <- start_vals$lengths
    cu_pa$mLe  <- max(start_vals$lengths$Length)
}

cu_pa$ThetaMat <- getPmat(cu_pa$Theta,cu_pa$Rho,cu_pa$acgt)

#######################################################
#
#              Setting the lambda vector 
#
#######################################################

cu_pa$laVec <- seqProbVecLambda(cu_pa$Lambda,cu_pa$LambdaDisp,nrow(cu_pa$dat),cu_pa$forward_only,cu_pa$reverse_only)

if (!cu_pa$same_overhangs){
    #The overhangs are not the same
    if (cu_pa$forward_only){
        write("Cannot use different overhangs with only the 5' end",stderr())
        stop()
    } else if (cu_pa$reverse_only){
        write("Cannot use different overhangs with only the 3' end",stderr())
        stop()
    }
    cu_pa$laVecRight <- seqProbVecLambda(cu_pa$LambdaRight,cu_pa$LambdaDisp,nrow(cu_pa$dat),cu_pa$forward_only,cu_pa$reverse_only)
}

#######################################################
#
#              Setting the nu vector 
#
#######################################################

if (!cu_pa$ds_protocol & cu_pa$nuSamples!=0){
    #Using the single stranded protocol with nu samples which makes 
    #no sense
    write("Silly to use the MC estimation for nu_i if using the single stranded protocol", stderr())
    stop()
}else if (cu_pa$nuSamples!=0 & cu_pa$fix_nu) {
    #Using the fixed nu parameter with nu samples which makes no sense 
    write("Silly to use the MC estimation for nu_i and use fix_nu ", stderr())
    stop()
}else if (cu_pa$nuSamples!=0){
    #Using the nu vector
    #IF ds protocol we set nu_vector as 1
    cu_pa$nuVec <- seqProbVecNuWithLengths(cu_pa$Lambda,
                                       cu_pa$LambdaDisp,
                               cu_pa$Nu,nrow(cu_pa$dat),
                               sampleHJ(cu_pa$lengths$Length,size=cu_pa$nuSamples,prob=cu_pa$lengths$Occurences),
                                              cu_pa$mLe,
                                     cu_pa$forward_only,
                                        cu_pa$nuSamples,
                                      cu_pa$ds_protocol)
}else if (!cu_pa$ds_protocol){
    #The single stranded protocol
    cu_pa$nuVec <- rep(1,nrow(dat))
}else if (fix_nu){
    #Ones at the 5' end and zeros at the 3' end
    if (cu_pa$forward_only){
        cu_pa$nuVec <- rep(1,nrow(dat))
    }else if (cu_pa$reverse_only){
        cu_pa$nuVec <- rep(0,nrow(dat))
    }else {
        cu_pa$nuVec <- c(rep(1,nrow(dat)/2),rep(0,nrow(dat)/2))
    }
}else {
    #This is for a non linear nick frequency, assumes the G>T and G>A are 
    #mostly due to DNA damage patterns do not use for low damage datasets
    te<-(dat[,"C.T"]/dat[,"C"])/(dat[,"G.A"]/dat[,"G"]+dat[,"C.T"]/dat[,"C"])
    if (sum(is.na(te) )!=0 ){
        write("Warning, To few substitutions to assess the nick frequency, using constant nick frequency instead", stderr())
        if (cu_pa$forward_only){
            cu_pa$nuVec <- rep(1,nrow(dat))
        }else if (cu_pa$reverse_only){
            cu_pa$nuVec <- rep(0,nrow(dat))
        }else {
            cu_pa$nuVec <- c(rep(1,nrow(dat)/2),rep(0,nrow(dat)/2))
        }
    } else {
        #The substitutes seem to be okay estimate the nick frequency using GAM 
        if (cu_pa$forward_only || cu_pa$reverse_only){
            if (cu_pa$use_raw_nick_freq){
                #Use the frequency
                cu_pa$nuVec <- te
            }else{
                #Use a smoother
                cu_pa$nuVec  <- predict(gam(te~s(1:(cu_pa$m))))
            }
        }else {
            if (cu_pa$use_raw_nick_freq){
                cu_pa$nuVec  <- c(te[1:(cu_pa$m/2)],te[(cu_pa$m/2+1):cu_pa$m])
            }else{
                cu_pa$nuVec  <- c(predict(gam(te[1:(cu_pa$m/2)]~s(1:(cu_pa$m/2)))),
                                  predict(gam(te[(cu_pa$m/2+1):cu_pa$m]~s(1:(cu_pa$m/2)))))
            }
        }
        #This shouldn't happen but for sanity check
        cu_pa$nuVec[cu_pa$nuVec>1] <- 1
        cu_pa$nuVec[cu_pa$nuVec<0] <- 0
    }
    rm(te)
}
#######################################################
#
#          Finding an "optimal" starting place 
#
#######################################################

if (grid_iter!=0){
    #Start at random places and optimize the likelihood function
    cu_pa <- gridSearch(cu_pa,grid_iter) 
} 

#Calculate the log likelihood in the beginning
if (cu_pa$same_overhangs){
    te_laVec <- cu_pa$laVec
}else {
    te_laVec <- c(cu_pa$laVec[1:(cu_pa$m/2)],cu_pa$laVecRight[(cu_pa$m/2+1):cu_pa$m])
}
cu_pa$old_lik <- logLikAll(cu_pa$dat,
                      cu_pa$ThetaMat,
                        cu_pa$DeltaD,
                        cu_pa$DeltaS,
                         te_laVec,
                         cu_pa$nuVec,
                             cu_pa$m
                  )


if (adjust_iter==0){
    #Single burning period
    if (!cu_pa$quiet){
        cat("Single burn in period\n")
    }
    mcmcOut <- runGibbs(cu_pa,burn_in)
    cu_pa <- mcmcOut$cu_pa
}else {
    for (i in 1:adjust_iter){
        if (!cu_pa$quiet){
            cat("Adjusting the proposal variance iteration ",i," \n")
        }
        mcmcOut <- runGibbs(cu_pa,burn_in)
        cu_pa <- mcmcOut$cu_pa
        proposeParameters <- adjustPropVar(mcmcOut,proposeParameters)
    }
}

if (!cu_pa$quiet){
    cat("Done burning, starting the iterations\n")
}
mcmcOut <- runGibbs(cu_pa,iterations)
cu_pa <- mcmcOut$cu_pa

if (!cu_pa$quiet){
    cat("Done with the iterations, finishing up\n")
}

if (out_file_base!=""){
    cat("Writing and plotting to files\n")
    #Print everything to file
    writeMCMC(mcmcOut,paste(out_file_base,"_MCMC_iter",sep=""))
    #Trace plot
    pdf(paste(out_file_base,"_MCMC_trace.pdf",sep=""))
    plotEverything(mcmcOut,hi=0)
    dev.off()
    #histogram of the conditional distributions
    pdf(paste(out_file_base,"_MCMC_hist.pdf",sep=""))
    plotEverything(mcmcOut,hi=1)
    dev.off()
    #Posterior predictive plot 
    pdf(paste(out_file_base,"_MCMC_post_pred.pdf",sep=""))
    siteProb <- postPredCheck(dat,mcmcOut)
    dev.off()
    #Write correcting probabilities 
    write.csv(siteProb,paste(out_file_base,"_MCMC_correct_prob.csv",sep=""))
} else {
    cat("Plotting\n")
    plotEverything(mcmcOut,hi=0)
    X11()
    plotEverything(mcmcOut,hi=1)
    X11()
    postPredCheck(dat,mcmcOut)
}

#Prior and proposal distributions for the parameter,
#they are all uninformative.

priorTheta <- function(x){
    return(dnorm(x=x,mean=1,sd=500,log=TRUE))
}

priorRho <- function(x){
    return(dnorm(x=x,mean=1,sd=500,log=TRUE))
}

priorDeltaD <- function(x){
    if (x<0 || x>1){
        return(-Inf)
    }
    return(dbeta(x=x,shape1=1,shape2=1,log=TRUE))
}

priorDeltaS <- function(x){
    if (x<0 || x>1){
        return(-Inf)
    }
    return(dbeta(x=x,shape1=1,shape2=1,log=TRUE))
}

priorLambda <- function(x){
    if (x<0 || x>1){
        return(-Inf)
    }
    return(dbeta(x=x,shape1=1,shape2=1,log=TRUE))
}

priorLambdaRight <- function(x){
    if (x<0 || x>1){
        return(-Inf)
    }
    return(dbeta(x=x,shape1=1,shape2=1,log=TRUE))
}

priorLambdaDisp <- function(x){
    if (x<0){
        return(-Inf)
    }
    #2 times since we truncate it at zero
    return(log(2)+dnorm(x=x,mean=0,sd=100,log=TRUE))
}

priorNu <- function(x){
    if (x<0 || x>1){
        return(-Inf)
    }
    return(dbeta(x=x,shape1=1,shape2=1,log=TRUE))
}

proposeTheta <- function(x=NA,ra=NA){
    sh1 <- proposeParameters$Theta 
    if (!is.na(ra)){
        return(rnorm(1,mean=x,sd=sh1))
    } else {
        return(0)
    }
}

proposeRho <- function(x=NA,ra=NA){
    sh1 <- proposeParameters$Rho 
    if (!is.na(ra)){
        return(rnorm(1,mean=x,sd=sh1))
    } else {
        return(0)
    }
}

proposeDeltaD <- function(x=NA,ra=NA){
    sh1 <- proposeParameters$DeltaD
    if (!is.na(ra)){
        return(rnorm(1,mean=x,sd=sh1))
    } else {
        return(0)#Okay since norm is symmetric
    }
}

proposeDeltaS <- function(x=NA,ra=NA){
    sh1 <- proposeParameters$DeltaS 
    if (!is.na(ra)){
        return(rnorm(1,mean=x,sd=sh1))
    } else {
        return(0)
    }
}

proposeLambda <- function(x=NA,ra=NA){
    sh1 <- proposeParameters$Lambda
    if (!is.na(ra)){
        return(rnorm(1,mean=x,sd=sh1))
    } else {
        return(0)
    }
}

proposeLambdaRight <- function(x=NA,ra=NA){
    sh1 <- proposeParameters$LambdaRight
    if (!is.na(ra)){
        return(rnorm(1,mean=x,sd=sh1))
    } else {
        return(0)
    }
}

proposeLambdaDisp <- function(x=NA,ra=NA){
    sh1 <- proposeParameters$LambdaDisp
    if (!is.na(ra)){
        return(rnorm(1,mean=x,sd=sh1))
    } else {
        return(0)
    }
}

proposeNu <- function(x=NA,ra=NA){
    sh1 <- proposeParameters$Nu
    if (!is.na(ra)){
        return(rnorm(1,mean=x,sd=sh1))
    } else {
        return(0)
    }
}
